#!/usr/bin/perl -w
# PentiumParts dal.net away system for x-chat
# 1.0.3 changes:
#	- Made user actually /away
#	- Didn't change nick if user wasn't actually away with pp_aw script
# 1.0.6 changes:
#	- made away message more readable in mIRC default colors
#	- open a window to yourself for logs and force all messages to it.
#	- made away outgoing messages hidden to x-chat to clean up the
#	  <mynick>_AFK window.

$pp_away_ver = "1.0.5";
$pp_logo = "\00314,1P\00315t\0030\0038m \0037P\0034t \00311";
$pp_away = "N";
$pp_old_nick = "None";

IRC::print "$pp_logo Loading away system v$pp_away_ver\003 \n";

IRC::add_message_handler("NOTICE", "pp_away_handler");
IRC::add_message_handler("PRIVMSG", "pp_away_handler");
IRC::add_command_handler("aw", "pp_aw");
IRC::add_command_handler("back", "pp_back");

# if someone messages you, tell them you are away.
sub pp_away_handler 
{
  my $pp_line = shift(@_);
  $pp_line =~ /:([^!]*)![^@]*@[^ ]* [^:]*:(.*)/;
  my $pp_from_user = $1;
  my $pp_message = $2;
  my $pp_my_channel = IRC::get_info(2);
  my $pp_my_time = sprintf "%02d:%02d", (localtime)[2], (localtime)[1];
  $pp_my_nick = IRC::get_info(1);

  if ( ($pp_away_status == 0) || ($pp_from_user =~ /$pp_my_nick/i) )
  {
    return 0
  };

  if ($pp_line =~ /$pp_my_nick/i) 
  {
    IRC::command("/query $pp_my_nick");
    IRC::command(qq{/msg $pp_my_nick $pp_logo AWAY LOG - $pp_my_time <$pp_from_user>"$pp_message"\n});
    IRC::command("/RAW PRIVMSG $pp_from_user :$pp_logo I am away $pp_away.  Your message has been logged.");
  }	
 
  return 0;
}

# /aw command - makes user away
sub pp_aw
{
  my $pp_line = shift(@_);
  my $pp_my_channel = IRC::get_info(2);
  
  $pp_old_nick = IRC::get_info(1);

  ($pp_away_status == 1) ? ($pp_away_status = 0) : ($pp_away_status = 1);

  $pp_away = $pp_line;
  $pp_new_nick = sprintf("%s%s", $pp_old_nick, "_AFK");

  IRC::command("/nick $pp_new_nick");
  IRC::command("/msg $pp_my_channel $pp_logo is away $pp_away\003");
  IRC::command("/away $pp_away");
  
  return 1;
}

# /back command - returns user to active mode
sub pp_back
{
  my $pp_my_channel = IRC::get_info(2);

  if( $pp_away_status == 1 ) {
  	IRC::command("/msg $pp_my_channel is returning from $pp_away.\n");
  	$pp_away = "N";
  	$pp_away_status = 0;
  	IRC::command("/nick $pp_old_nick");
  }
  IRC::command("/away");
  return 1;
}
