#!/usr/bin/perl -w
# PentiumParts dal.net Auto-Identify for x-chat
# v1.0.3 changes:
#	- Corrected nickserv request string for new format
#	- Hid outgoing identify strings by using /RAW instead of /msg

$pp_identify_ver = "1.0.5";
$pp_logo = "\00314,1P\00315t\0030\0038m \0037P\0034t \00311";
IRC::print "$pp_logo Loading auto-identify script v$pp_identify_ver\003 \n";

IRC::add_message_handler("NOTICE", "notice_handler");
IRC::add_command_handler("identify", "pp_identify");
IRC::add_command_handler("identifyall", "pp_identifyall");
IRC::add_command_handler("pp_load_passwords", "pp_load_passwords");


# watch for NickServ asking for passwords
# sub privmsg_handler 
sub notice_handler 
{
  my $line = shift(@_);
  my $pp_current_nick = IRC::get_info(1);

  $line =~ /:(.*)!(.*@.*) .*:(.*)/;
  if ($1 =~ /NickServ/) {
    if ($line =~ 
    /This nick is owned by someone else. Please choose another./)
    {
       pp_identify($pp_current_nick);
       return 1;
    } else {
       $line =~ /:(.*)!(.*@.*) .*:(.*)/;
    }
  }
  return 0;
}

# nickserv identify
sub pp_identify
{
  my $pp_nick = shift(@_);
  my $pp_current_nick = IRC::get_info(1);
  
  if( $pp_nick eq "" ) {
    $pp_my_nick = $pp_current_nick;
  }

  $pp_first = substr($pp_nick, 0, 1);

  if( defined $pp_password ) {
  } else {
  	pp_load_passwords();
  }
    
  if( "#" eq $pp_first ) {
    # channel identification
    IRC::command("/RAW PRIVMSG ChanServ\@services.dal.net :identify $pp_nick $pp_password{lc($pp_nick)}");
    IRC::command("/RAW PRIVMSG ChanServ\@services.dal.net :op $pp_nick $pp_current_nick");
  } else {
    # nick identification
    if( $pp_nick eq IRC::get_info(1) ) {
      IRC::command("/RAW PRIVMSG NickServ\@services.dal.net :identify $pp_password{lc($pp_nick)}");
    } else {
      IRC::command("/RAW PRIVMSG NickServ\@services.dal.net :identify $pp_nick $pp_password{lc($pp_nick)}");
    }
  }
  return 1;
}

# nickserv/chanserv identify for all nicks/channels
sub pp_identifyall
{
  IRC::print "\00314P\00315t\0031\0037m P\0034t \00311Identifying all known nicks and channels.\033 \n";
  foreach(@pp_password_nicks)
  {
  	pp_identify($_);
  } 
  return 1;
}


# load password file
sub pp_load_passwords
{
	$pp_filename = shift(@_);
	if( $pp_filename eq "" ) {
		$pp_filename = ".ppx_passwords";
	}
	@pp_password_nicks = "";
	open(PP_FH, "< $pp_filename");
	while (<PP_FH>) {
		chomp;
		($pp_nick, $pp_password) = split(/\s+/, $_);
		push(@pp_password_nicks, lc($pp_nick));
		$pp_password{lc($pp_nick)} = $pp_password;
	}
	close(PP_FH);
}

