#!/usr/bin/perl
# PentiumParts dal.net MP3 support for x-chat
# 1.0.6 - initial release
#	/mp3list (!<mynick>-list)
#		creates a new list and sends it including subdirectories
#	/mp3send (!<mynick> <file>)
#		finds files with the mask <file> and sends 'em including subdirectories
#	/mp3play <filename>
#		Advertises and plays the mp3 file specified.


$pp_mp3_ver = "1.0.6";
$pp_logo = "\00314,1P\00315t\0030\0038m \0037P\0034t \00311";
$pp_bj = "g Jh";
$pp_mp3_path = "/home/ftp/pub/mp3";
$pp_mp3_command = "mpg123";
IRC::print "$pp_logo Loading $pp_bj MP3 script v$pp_mp3_ver\003 \n";

IRC::add_command_handler("mp3play", "pp_mp3_play");
IRC::add_command_handler("mp3send", "pp_mp3_send");
IRC::add_command_handler("mp3list", "pp_mp3_sendlist");
IRC::add_message_handler("NOTICE", "MP3_handler");
IRC::add_message_handler("PRIVMSG", "MP3_handler");


# Play and advertize an MP3
sub pp_mp3_play
{
	my $pp_findfile = shift(@_);
	my $pp_chan = IRC::get_info(2);

	if( pp_mp3play($pp_findfile) == 0 ) {
		IRC::command("/CTCP $pp_chan MP3 $pp_findfile");
	} else {
		IRC::print("$pp_logo MP3 $pp_findfile not found!\n");
	}
	return 1;
}


sub pp_mp3play
{
	my $pp_findfile = shift(@_);
	my $pp_chan = IRC::get_info(2);

###IRC::print("$pp_logo DEBUG - MP3 play [$pp_findfile] requested\n");
	my $pp_queuefile = "./PentiumParts/MyQueue.txt";
	`find $pp_mp3_path -name $pp_findfile -print > $pp_queuefile`;
	if(!(open(FILELIST, $pp_queuefile))) {
		IRC::print("$pp_logo **ERROR** $pp_queuefile file not found.\n");
	} else {
		$pp_file = <FILELIST>;
		close(FILELIST);
### DEFECT - Why doesn't this command execute in the background?
###		`$pp_mp3_command $pp_file &`;
		`rm $pp_queuefile`;
		return 0;
	}
	return 1;
}

# Send an MP3 to a user
sub pp_mp3_send
{
	my $pp_parms = shift(@_);

	($pp_nick, $pp_file) = split(" ", $pp_parms);
	IRC::print("$pp_logo finding $pp_file for $pp_nick.\n");
	$pp_queuefile = "./PentiumParts/$pp_nick.queue";
	`find $pp_mp3_path -name $pp_file -print > $pp_queuefile`;
	if(!(open(FILELIST, $pp_queuefile))) {
		# file not found
		IRC::print("$pp_logo **ERROR** $pp_queuefile file not found.\n");
	} else {
		$pp_file_listvar = <FILELIST>;
		@pp_file_list = split(/\n/,$pp_file_listvar);
		foreach $pp_file (@pp_file_list) {
			IRC::print("/DCC SEND $pp_nick $pp_file\n");
		}
		close(FILELIST);
		`rm $pp_queuefile`;
	}
	return 1;
}

# sub MP3_handler
sub MP3_handler 
{
	my $line = shift(@_);
	chomp;
	$pp_my_nick = IRC::get_info(1);
	my $pp_chan = IRC::get_info(2);
	my $pp_from = "";
	my $pp_notice = "";
	my $pp_me = "";
	my $pp_key = "";
	my $pp_file = "";
	my $pp_rest = "";
  
	($pp_from, $pp_notice, $pp_me, $pp_key, $pp_file, $pp_rest) = split(/\s+/, $line);
  	$pp_from =~ s/://;
	$pp_from =~ s/\!\S+//;
	$pp_file =~ s/mp3\W+/mp3/g;
  	$pp_key =~ s/://;
  	$pp_key =~ s/\W//g;
####		IRC::print("\0038pp_from \0037$pp_from\n\0038pp_notice \0037$pp_notice\n\0038pp_me \0037$pp_me\n\0038pp_key \0037$pp_key\n\0038pp_file \0037$pp_file\n\0038pp_rest \0037$pp_rest\n");

	# request file list
	# !<nick>-list
	if( 
		( lc($pp_key) =~ lc(":!$pp_my_nick-list") ) 
	) {
		pp_mp3_sendlist($pp_from);
		return 1;
	}

	# file send request
	# !<nick> <file>
	if( 
		( lc($pp_key) =~ lc(":!$pp_my_nick") ) ||
		( lc($pp_key) =~ lc(":DCC_SEND") )
	) {
		pp_mp3_send("$pp_from $pp_file");
		return 1;
	}

	# Play an MP3 file
	# CTCP MP3 <file>
	if( lc($pp_key) =~ lc("MP3") ) {
		IRC::print("$pp_logo MP3 Playing $pp_file from $pp_from.\n");
		if( pp_mp3play($pp_file) == 1 ) {
			# file not found...
			IRC::print("$pp_logo MP3 $pp_file not found... requesting it\n");
			IRC::command("/MSG $pp_chan !$pp_from $pp_file");
		}
		return 1;
	}
	return 0;
}

sub pp_mp3_sendlist
{
	my $pp_nick = shift(@_);
	chomp;
	$pp_my_nick = IRC::get_info(1);
	$pp_mp3listfile = $pp_my_nick;
	$pp_mp3listfile = $pp_my_nick."_mp3list.txt";
	IRC::print("$pp_logo MP3 - sending list [$pp_mp3listfile] to $pp_nick\n");

	# Generating list...
	IRC::command("/RAW PRIVMSG $pp_nick :$pp_logo Generating fresh MP3 list... please stand by...");
	`find /home/ftp/pub/mp3/ -name "*.mp3" -type f -printf "%f\n" | sort > ~/PentiumParts/$pp_mp3listfile`;

	# sending the list
	IRC::command("/RAW PRIVMSG $pp_nick :$pp_logo Sending my MP3 list, n-joy!");
	IRC::command("/DCC SEND $pp_nick ~/PentiumParts/$pp_mp3listfile");

	return 1;
}

